# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.AddTimestep
import SEAScope.API.Command

import SEAScope.types.timespan


def serialize(builder, step_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _timestep = SEAScope.types.timestep.serialize(builder, step_obj)

    cls = SEAScope.API.AddTimestep
    cls.AddTimestepStart(builder)
    cls.AddTimestepAddTimestep(builder, _timestep)
    cmd_args = cls.AddTimestepEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().addTimestep
    args_type = SEAScope.API.CommandArgs.CommandArgs().AddTimestep
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
