# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-04
"""

import flatbuffers
import SEAScope.API.GetCataloguesResponse
import SEAScope.types.source


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().getCatalogues
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.GetCataloguesResponse.GetCataloguesResponse
    res = cls.GetRootAsGetCataloguesResponse(buf, 0)

    result = {'sources': [], 'collections': []}

    srcs_count = res.SourcesLength()
    for i in range(0, srcs_count):
        src = SEAScope.types.source.deserialize(res.Sources(i))
        result['sources'].append(src)

    collections_count = res.CollectionsLength()
    for i in range(0, collections_count):
        collection = SEAScope.types.collection.deserialize(res.Collections(i))
        result['collections'].append(collection)

    return result
