# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-06
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListSourcesResponse
import SEAScope.API.Command

import SEAScope.types.source


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listSources
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.ListSourcesResponse.ListSourcesResponse
    res = cls.GetRootAsListSourcesResponse(buf, 0)
    sources_count = res.SourcesLength()
    result = []
    for i in range(0, sources_count):
        src = SEAScope.types.source.deserialize(res.Sources(i))
        result.append(src)
    return result
