# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListTimestepsResponse
import SEAScope.API.Command

import SEAScope.types.timestep


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listTimesteps
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.ListTimestepsResponse.ListTimestepsResponse
    res = cls.GetRootAsListTimestepsResponse(buf, 0)
    timesteps_count = res.TimestepsLength()
    result = []
    for i in range(0, timesteps_count):
        t = SEAScope.types.timestep.deserialize(res.Timesteps(i))
        result.append(t)
    return result
