# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListVariablesResponse
import SEAScope.API.Command
import SEAScope.types.variable


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listVariables
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.ListVariablesResponse.ListVariablesResponse
    res = cls.GetRootAsListVariablesResponse(buf, 0)
    vars_count = res.VariablesLength()
    result = []
    for i in range(0, vars_count):
        var_obj = SEAScope.types.variable.deserialize(res.Variables(i))
        result.append(var_obj)

    return result
