# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-06
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.RemoveCollection
import SEAScope.API.Command
import SEAScope.types.renderable_id


def serialize(builder, rid):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _rid = SEAScope.types.renderable_id.serialize(builder, rid)

    cls = SEAScope.API.RemoveCollection
    cls.RemoveCollectionStart(builder)
    cls.RemoveCollectionAddCollectionId(builder, _rid)
    cmd_args = cls.RemoveCollectionEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().removeCollection
    args_type = SEAScope.API.CommandArgs.CommandArgs().RemoveCollection
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
