# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.RemoveTimestep
import SEAScope.API.Command

import SEAScope.types.timestep


def serialize(builder, label):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _label = builder.CreateString(label)

    cls = SEAScope.API.RemoveTimestep
    cls.RemoveTimestepStart(builder)
    cls.RemoveTimestepAddLabel(builder, _label)
    cmd_args = cls.RemoveTimestepEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().removeTimestep
    args_type = SEAScope.API.CommandArgs.CommandArgs().RemoveTimestep
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
