# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.RemoveVariable
import SEAScope.API.Command

import SEAScope.types.renderable_id


def serialize(builder, var_id):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _id = SEAScope.types.renderable_id.serialize(builder, var_id)

    cls = SEAScope.API.RemoveVariable
    cls.RemoveVariableStart(builder)
    cls.RemoveVariableAddVariableId(builder, _id)
    cmd_args = cls.RemoveVariableEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().removeVariable
    args_type = SEAScope.API.CommandArgs.CommandArgs().RemoveVariable
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
