# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.SearchGranules
import SEAScope.API.SearchGranulesResponse
import SEAScope.API.Command
import SEAScope.types.collection_id
import SEAScope.types.granule_metadata


def serialize(builder, search_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.SearchGranules

    collectionsOffsets = 0
    cls.SearchGranulesStartCollectionsVector(builder,
                                             len(search_obj['collections']))
    for collection in search_obj['collections']:
        SEAScope.types.collection_id.serialize(builder, collection)
    collectionsOffsets = builder.EndVector(len(search_obj['collections']))

    cls.SearchGranulesStart(builder)
    cls.SearchGranulesAddCurrent(builder, search_obj['current'])
    cls.SearchGranulesAddStart(builder, search_obj['start'])
    cls.SearchGranulesAddStop(builder, search_obj['stop'])
    cls.SearchGranulesAddZoom(builder, search_obj['zoom'])
    cls.SearchGranulesAddCollections(builder, collectionsOffsets)
    cmd_args = cls.SearchGranulesEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().searchGranules
    args_type = SEAScope.API.CommandArgs.CommandArgs().SearchGranules
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    deserializer = SEAScope.types.granule_metadata.deserialize
    cls = SEAScope.API.SearchGranulesResponse.SearchGranulesResponse
    res = cls.GetRootAsSearchGranulesResponse(buf, 0)

    l = res.GranulesLength()
    return [deserializer(res.Granules(x)) for x in range(0, l)]
