# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2017-05-15
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.SetAltitude
import SEAScope.API.Command


def serialize(builder, altitude):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.SetAltitude
    cls.SetAltitudeStart(builder)
    cls.SetAltitudeAddAltitude(builder, altitude)
    cmd_args = cls.SetAltitudeEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().setAltitude
    args_type = SEAScope.API.CommandArgs.CommandArgs().SetAltitude
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
