# -*- encoding: utf-8 -*-

"""
"""

import math

def create_collection(unique_id, label):
    """"""
    _rid = {'granuleLevel': False,
            'sourceId': 1,
            'collectionId': unique_id,
            'granuleId': 0,
            'variableId': 0}
    result = {'id': _rid,
              'mustBeCurrent': False,
              'xSeamless': False,
              'ySeamless': False,
              'label': label,
              'tags': {},
              'variables': [],
              'defaultVariable': 0}
    return result


def create_variable(unique_id, label):
    """"""
    result = {'id': unique_id,
              'label': label,
              'units': '',
              'fields': [],
              'defaultRenderingMethod': 'RASTER',
              'tags': {}}
    return result

def create_rendering_config(col_id=0, var_id=0):
    """"""
    target = {'granuleLevel': False,
              'sourceId': 1,
              'collectionId': col_id,
              'granuleId': 0,
              'variableId': var_id}

    result = {'rendered': True,
              'logscale': False,
              'min': 0,
              'max': 0,
              'opacity': 1.0,
              'zindex': 500,
              'color': [50, 12, 87],
              'colormap': 'grayscale',
              'renderMethod': 'RASTER',
              'particlesCount': 1000,
              'particleTTL': 10,
              'streamlineLength': 20,
              'streamlineSpeed': 0.0,
              'filterMode': 'NEAREST',
              'target': target}
    return result


def create_info(result, channels, offset, scale, fill_value):
    """"""
    result = {'channels': channels,
              'xArity': result.shape[0],
              'yArity': result.shape[1],
              'dataType': 'uint8',
              'offsets': [offset],
              'scaleFactors': [scale],
              'fillValues': [fill_value]}
    return result


def create_metadata(collection_id, variable_id, granule_id, data_id, gcps,
                    start, stop, data_info):
    """"""
    shape_arity = math.sqrt(len(gcps))
    shape = {'xArity': shape_arity,
             'yArity': shape_arity,
             'gcps': gcps}
    rid = {'granuleLevel': True,
           'sourceId': 1,
           'collectionId': collection_id,
           'granuleId': granule_id,
           'variableId': variable_id}
    idf = {'uri': '{}_{}'.format(data_id, granule_id),
           'xArity': data_info['xArity'],
           'yArity': data_info['yArity'],
           'resolution': 1000000000,
           'subsampling_factor': 0,
           'shape': shape}
    metadata = {'sourceId': 1,
                'collectionId': collection_id,
                'granuleId': granule_id,
                'dataId': data_id,
                'dataModel': 'ROW_CELL',
                'start': start,
                'stop': stop,
                'uris': [idf],
                'title': data_id,
                'institution': '',
                'comment': '',
                'file_id': idf['uri'],
                'product_version': '0.0.0',
                'lat_min' : min([gcp['lat'] for gcp in gcps]),
                'lat_max' : max([gcp['lat'] for gcp in gcps]),
                'lon_min' : min([gcp['lon'] for gcp in gcps]),
                'lon_max' : max([gcp['lon'] for gcp in gcps]),
                'creator_email': '',
                'station_id': '',
                'platform': '',
                'sensor': ''}

    return rid, metadata
