# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-02
"""

import flatbuffers
import SEAScope.API.DataInfo
import SEAScope.API.DataType

data_types = {
    'none': SEAScope.API.DataType.DataType.NONE,
    'uint8': SEAScope.API.DataType.DataType.UBYTE,
    'ushort16': SEAScope.API.DataType.DataType.USHORT,
    'uint32': SEAScope.API.DataType.DataType.UINT,
    'float32': SEAScope.API.DataType.DataType.FLOAT32}


def serialize(builder, info_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.DataInfo

    l = len(info_obj['offsets'])
    cls.DataInfoStartOffsetsVector(builder, l)
    for v in info_obj['offsets'][::-1]:
        builder.PrependFloat32(v)
    offsets = builder.EndVector(l)

    l = len(info_obj['scaleFactors'])
    cls.DataInfoStartScaleFactorsVector(builder, l)
    for v in info_obj['scaleFactors'][::-1]:
        builder.PrependFloat32(v)
    scale_factors = builder.EndVector(l)

    l = len(info_obj['fillValues'])
    cls.DataInfoStartFillValuesVector(builder, l)
    for v in info_obj['fillValues'][::-1]:
        builder.PrependFloat32(v)
    fill_values = builder.EndVector(l)

    _data_type = data_types.get(info_obj['dataType'], data_types['none'])
    print(_data_type)

    cls.DataInfoStart(builder)
    cls.DataInfoAddChannels(builder, info_obj['channels'])
    cls.DataInfoAddXArity(builder, info_obj['xArity'])
    cls.DataInfoAddYArity(builder, info_obj['yArity'])
    cls.DataInfoAddDataType(builder, _data_type)
    cls.DataInfoAddOffsets(builder, offsets)
    cls.DataInfoAddScaleFactors(builder, scale_factors)
    cls.DataInfoAddFillValues(builder, fill_values)
    data_info = cls.DataInfoEnd(builder)

    return builder, data_info


def deserialize(o):
    """"""
    pass
