# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-10-20
"""

import flatbuffers
import SEAScope.types.renderable_id
import SEAScope.types.gcp

import struct
import flatbuffers.compat
import flatbuffers.number_types


def serialize(builder, obj):
    pass


def deserialize(o):
    result = {}
    result['id'] = SEAScope.types.renderable_id.deserialize(o.Id())
    result['xArity'] = o.XArity()
    result['yArity'] = o.YArity()
    result['channels'] = o.Channels()
    result['uri'] = o.Uri()

    shape_count = o.ShapeLength()
    shape = []
    for i in range(0, shape_count):
        gcp = SEAScope.types.gcp.deserialize(o.Shape(i))
        shape.append(gcp)
    result['shape'] = shape

    gcps_count = o.GcpsLength()
    gcps = []
    for i in range(0, gcps_count):
        gcp = SEAScope.types.gcp.deserialize(o.Gcps(i))
        gcps.append(gcp)
    result['gcps'] = gcps

    fill_values_count = o.FillValuesLength()
    fill_values = []
    for i in range(0, fill_values_count):
        fill_values.append(o.FillValues(i))
    result['fill_values'] = fill_values

    values_count = o.BufferLength()
    fmt = '<' + 'f' * values_count
    vs = struct.Struct(fmt)
    b_offset = o._tab.Offset(12)
    buffer_offset = flatbuffers.number_types.UOffsetTFlags.py_type(b_offset)
    vector_offset = o._tab.Vector(buffer_offset)
    values = vs.unpack_from(flatbuffers.compat.memoryview_type(o._tab.Bytes),
                            vector_offset)
    result['buffer'] = values

    return result
