# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-10-11
"""

import flatbuffers
import SEAScope.API.IDFDescriptor
import SEAScope.types.shape


def serialize(builder, obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    uri = builder.CreateString(obj['uri'])
    resolution = obj['resolution']
    subsampling_factor = obj['subsampling_factor']
    x_arity = obj['xArity']
    y_arity = obj['yArity']
    _, shape = SEAScope.types.shape.serialize(builder, obj['shape'])

    cls = SEAScope.API.IDFDescriptor
    cls.IDFDescriptorStart(builder)
    cls.IDFDescriptorAddUri(builder, uri)
    cls.IDFDescriptorAddResolution(builder, resolution)
    cls.IDFDescriptorAddXArity(builder, x_arity)
    cls.IDFDescriptorAddYArity(builder, y_arity)
    cls.IDFDescriptorAddShape(builder, shape)
    cls.IDFDescriptorAddSubsamplingFactor(builder, subsampling_factor)
    idf_descriptor = cls.IDFDescriptorEnd(builder)

    return builder, idf_descriptor


def deserialize(o):
    """"""
    result = {}
    result['uri'] = o.Uri()
    result['resolution'] = o.Resolution()
    result['xArity'] = o.XArity()
    result['yArity'] = o.YArity()
    result['shape'] = SEAScope.types.shape.deserialize(o.Shape())
    result['subsampling_factor'] = o.SubsamplingFactor()
    return result
