# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-09
"""

import flatbuffers
import SEAScope.API.Shape
import SEAScope.types.gcp


def serialize(builder, shp_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    x_arity = shp_obj['xArity']
    y_arity = shp_obj['yArity']
    l = len(shp_obj['gcps'])
    SEAScope.API.Shape.ShapeStartGcpsVector(builder, l)
    for gcp in shp_obj['gcps']:
        _, _gcp = SEAScope.types.gcp.serialize(builder, gcp)
    gcps = builder.EndVector(l)

    cls = SEAScope.API.Shape
    cls.ShapeStart(builder)
    cls.ShapeAddXArity(builder, x_arity)
    cls.ShapeAddYArity(builder, y_arity)
    cls.ShapeAddGcps(builder, gcps)
    shape = cls.ShapeEnd(builder)
    return builder, shape


def deserialize(o):
    """"""
    deserializer = SEAScope.types.gcp.deserialize
    s_obj = {}
    s_obj['xArity'] = o.XArity()
    s_obj['yArity'] = o.YArity()
    gcps_count = o.GcpsLength()
    s_obj['gcps'] = [deserializer(o.Gcps(x)) for x in range(0, gcps_count)]

    return s_obj
