# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-07
"""

import flatbuffers
import SEAScope.API.Source
import SEAScope.types.tag


def serialize(builder, src_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.Source

    _title = builder.CreateString(src_obj['title'])
    _description = builder.CreateString(src_obj['description'])

    tags = []
    l = len(src_obj['tags'].keys())
    for k, v in src_obj['tags'].items():
        _, tag = SEAScope.types.tag.serialize(builder, k, v)
        tags.append(tag)
    cls.SourceStartTagsVector(builder, l)
    for t in tags:
        builder.PrependUOffsetTRelative(t)
    _tags = builder.EndVector(l)

    cls.SourceStart(builder)
    cls.SourceAddId(builder, src_obj['id'])
    cls.SourceAddTitle(builder, _title)
    cls.SourceAddDescription(builder, _description)
    cls.SourceAddTags(builder, _tags)
    source = cls.SourceEnd(builder)

    return builder, source


def deserialize(o):
    """"""
    src_obj = {}
    src_obj['id'] = o.Id()
    src_obj['title'] = o.Title()
    src_obj['description'] = o.Description()
    src_obj['tags'] = {}
    tags_count = o.TagsLength()
    for i in range(0, tags_count):
        name, value = SEAScope.types.tag.deserialize(o.Tags(i))
        src_obj['tags'][name] = value

    return src_obj
